<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.core.Sample"
	import="net.sf.basedb.core.BioMaterialList"
	import="net.sf.basedb.core.BioWell"
	import="net.sf.basedb.core.BioPlate"
	import="net.sf.basedb.core.AnyToAny"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.extensions.Extension"
	import="net.sf.basedb.clients.web.Base"	
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="java.util.List"
	import="java.util.ArrayList"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%!
String getSampleForLocation(List<Sample> samples, int offset, int position)
{
	String name = "<i>empty</i>";
	int index = offset + position - 1;
	if (index < samples.size())
	{
		Sample s = samples.get(index);
		name = "<b>" + HTML.encodeTags(s.getName()) + "</b>";
		try
		{
			BioWell well = s.getBioWell();
			if (well != null)
			{
				BioPlate plate = well.getPlate();
				name += "<br>" + plate.getName() + " " + well.getCoordinate();
			}
		}
		catch (PermissionDeniedException ex)
		{}
	}
	return name;
}
%>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
final String root = request.getContextPath();
final int BLOCKS_PER_PAGE = 3;
final int SAMPLES_PER_BLOCK = 5;
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final Extension reggie = ExtensionsControl.get(dc).getExtension("net.sf.basedb.reggie");
	final User user = User.getById(dc, sc.getLoggedInUserId());
	final int listId = Values.getInt(request.getParameter("workList"));
	BioMaterialList workList = BioMaterialList.getById(dc, listId);
	
	ItemQuery<Sample> query = (ItemQuery<Sample>)workList.getMemberBioMaterials();
	
	query.join(Hql.leftJoin(null, "bioWell", "bw", null, true));
	query.join(Hql.leftJoin("bw", "bioPlate", "bp", null, true));
	
	// Sort by bioplate position
	query.order(Orders.asc(Hql.expression("coalesce(bp.name, 'zzzz')", null)));
	query.order(Orders.asc(Hql.property("bw", "row")));
	query.order(Orders.asc(Hql.property("bw", "column")));
	query.order(Orders.asc(Hql.property("id")));

	List<Sample> histology = query.list(dc);
	
	int totalBlocks = 1 + (histology.size()-1) / SAMPLES_PER_BLOCK;
	int totalPages = 1 + (totalBlocks-1) / BLOCKS_PER_PAGE;
%>
<base:page id="protocol" type="iframe" 
	favicon="<%=home+"/images/microscope.png"%>" 
	title="Lab protocol for FFPE/HE">
<base:head
	scripts="~../reggie-2.js,~histology_protocol.js" 
	styles="~../css/reggie-2.css,~../css/printable.css"
	>
	<style>
	table.protocolheader
	{
		width: 100%;
		border: 1px solid #000000;
		margin-bottom: 1em;
		border-collapse: collapse;
	}

	table.protocolheader > tbody > tr
	{
		vertical-align: top;
		height: 1.25em;
	}

	table.protocolheader > tbody > tr > th
	{
		text-align: left;
		font-size: 1.25em;
		background-color: #F0F0F0;
		padding: 2px;
	}
	
	table.protocolheader > tbody > tr > td
	{
		text-align: left;
		font-size: 1.25em;
		padding: 2px;
	}
	
	
	div.paraffinblock
	{
		margin-top: 1em;
		margin-bottom: 2em;
		height: 7cm;
	}
	
	div.paraffinblock .header
	{
		border: 1px solid #000000;
		width: 100%;
		border-collapse: collapse;
		height: 7cm;
	}
	
	div.paraffinblock .header th
	{
		text-align: left;
		font-size: 1em;
		background-color: #F0F0F0;
		padding: 2px;
	}
	
	div.paraffinblock .header td
	{
	
		text-align: left;
		font-size: 1em;
		padding: 2px;
	}
	
	div.paraffinblock .header .big
	{
		font-size: 1.25em;
	}
	
	div.paraffinblock .block
	{
		width: 100%;
		height: 7cm;
		border-collapse: collapse;
		border: 1px solid #000000;
	}
	
	div.paraffinblock .block td
	{
		vertical-align: top;
		border: 1px solid #000000;
		padding: 4px;
		width: 50%;
		text-align: center;
	}
	
	div.paraffinblock .block td img
	{
		float: left;
		margin-right: -16px;
	}
	</style>
</base:head>
<base:body>
	<div class="paper">

	<form name="reggie" id="wizard">
	
	<div id="all-protocol" style="display: none;">

	<div id="print-instructions" class="noprint fullwidth">
		<span class="button" id="print-button">
			<img src="../images/print.png">Print&hellip;
		</span>
		
		<span class="button" id="download-button" style="float: left;" data-list-id="<%=listId%>">
			<img src="../images/download.png">Download HE glass labels&hellip;
		</span>
		
		<br clear="all">
	</div>

	<%
	int pageNo = 0;
	for (int blockNo = 0; blockNo < totalBlocks; ++blockNo)
	{
		AnyToAny link = AnyToAny.getByName(dc, workList, "block."+(blockNo+1));
		BioPlate block = (BioPlate)link.getTo();
		int offset = SAMPLES_PER_BLOCK * blockNo;
		if (blockNo % BLOCKS_PER_PAGE == 0)
		{
			pageNo++;
			%>
			<div class="<%=blockNo > 0 ? "pagebreak" : ""%>"></div>
			<h1>Lab protocol for FFPE/HE v.1.0 <span class="reggie">Page <%=pageNo %> of <%=totalPages %></span></h1>
			
			<table class="protocolheader">
			<tr style="border-bottom: 1px solid #000000;">
				<th style="width: 15%;">Work list</th>
				<td style="width: 30%; border-right: 1px solid #000000;"><%=HTML.encodeTags(workList.getName())%></td>
			</tr>
			<tr>
				<td rowspan="1" colspan="2" style="width: 50%; border-right: 1px solid #000000;"><%=HTML.niceFormat(workList.getDescription()) %></td>
			</tr>
			</table>
			<%
		}
		%>
		<div class="paraffinblock">
			<table style="width: 100%; border: 1px solid #000000;">
			<tr>
				<td style="width: 50%;">

					<table class="header">
					<tr class="big">
						<th style="width: 35%;">Block</th>
						<td colspan="2" style="width: 65%;"><%=block.getName() %></td>
					</tr>
					
					<tr style="border-top: 1px solid #000000;">
						<th>Storage box</th>
						<td colspan="2" style="border-right: 1px solid #000000;"></td>
					</tr>
					
					<tr style="border-top: 1px solid #cccccc;">
						<th>Embedding</th>
						<td style="width: 32%; border-right: 1px solid #cccccc;"></td>
						<td style="width: 33%;"></td>
					</tr>
					
					<tr class="big" style="border-top: 1px solid #000000;">
						<th>Slides</th>
						<td colspan="2"><%=block.getName().replace("PB", "HE") %>.#</td>
					</tr>
					
					<tr style="border-top: 1px solid #000000;">
						<th>Storage box/pos</th>
						<td style="border-right: 1px solid #cccccc;"></td>
						<td></td>
					</tr>
					
					<tr style="border-top: 1px solid #cccccc;">
						<th>Sectioning</th>
						<td style="border-right: 1px solid #cccccc;"></td>
						<td></td>
					</tr>

					<tr style="border-top: 1px solid #cccccc;">
						<th>Staining</th>
						<td style="border-right: 1px solid #cccccc;"></td>
						<td></td>
					</tr>
				
					<tr style="border-top: 1px solid #000000;">
						<td colspan="3" style="height: 5em;">&nbsp;</td>
					</tr>
					</table>
				</td>
				
				<td style="width: 50%;">
					<table class="block">
					<tr>
					<td>
						<img src="../images/3.png"><%=getSampleForLocation(histology, offset, 3) %>
					</td>
					<td>
						<img src="../images/6.png"><i>Not used</i>
					</td>
					</tr>
					
					<tr>
					<td>
						<img src="../images/2.png"><%=getSampleForLocation(histology, offset, 2) %>
					</td>
					<td>
						<img src="../images/5.png"><%=getSampleForLocation(histology, offset, 5) %>
					</td>
					</tr>
					
					<tr>
					<td>
						<img src="../images/1.png"><%=getSampleForLocation(histology, offset, 1) %>
					</td>
					<td>
						<img src="../images/4.png"><%=getSampleForLocation(histology, offset, 4) %>
					</td>
					</tr>
				</table>
				
				</td>
			</tr>
			</table>

		</div>
		<%
	}
	%>
	</div>
	</form>
	</div>
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>